using PyPlot

function cm_lr(n,p)

#generate nearest-neighbor laplacian, with periodic boundary conditions
#k=4*eye(n)-circshift(eye(n),1)-circshift(eye(n),-1)-circshift(eye(n),2)-circshift(eye(n),-2)
k=2*eye(n)-circshift(eye(n),1)-circshift(eye(n),-1)

#insert off-diagonal elements
pr=p
k=k-pr.*circshift(eye(n),-int(n/2))+pr.*eye(n)

return k

end

function cm_order(n,p)

#generate nearest-neighbor laplacian, with periodic boundary conditions
k=2*eye(n)-circshift(eye(n),1)-circshift(eye(n),-1)

return k

end

function cm_do(n,p)

#generate nearest-neighbor laplacian, with periodic boundary conditions
k=2*eye(n)-circshift(eye(n),1)-circshift(eye(n),-1)


#insert defect
k[1,:]=k[1,:]*p

return k

end

function cm_do_rand(n,p)

#generate nearest-neighbor laplacian, with periodic boundary conditions
k=2*eye(n)-circshift(eye(n),1)-circshift(eye(n),-1)


#insert 2 defect
k[1,:]=k[1,:]*p
k[n/2,:]=k[n/2,:]*(1-p)


return k

end

function feidler(n,pp)

#lam=Array(Any,(length(pp),n))
#lam=zeros(Float64,(length(pp),n))
lam1=zeros(Float64,(length(pp)))
lam2=zeros(Float64,(length(pp)))
lam3=zeros(Float64,(length(pp)))
#free_shmem(:lam, "pfx")
#map_shmem(ShmemVar(:lam, Float64, length(pp)), "pfx")

for p =1:length(pp)
	lam1[p]=real(eig(cm_order(n,pp[p]))[1][2])
	lam2[p]=real(eig(cm_do(n,pp[p]))[1][2])
	lam3[p]=real(eig(cm_lr(n,pp[p]))[1][2])
end

#lamm=remotecall_fetch(1, () -> lam)
#writedlm("fiedler.txt", remotecall_fetch(1, () -> lam))
#free_shmem(:lam, "pfx")


return pp,lam1,lam2,lam3

end

function plot_f(n,pp)
	(pp,lam1,lam2,lam3)=feidler(n,pp)
	fig = figure()
	p1=loglog(pp,lam1,"b")
	p2=loglog(pp,lam2,"g")
	p3=loglog(pp,lam3,"r")
	setp(p1,"linewidth",3)
	setp(p2,"linewidth",3)
	setp(p3,"linewidth",3)
	xlab = xlabel(L"$P$")
	ylab = ylabel(L"$\Lambda_2$")
	legend([p1,p2,p3],loc=3,[L"Ordered",
                         L"Single Defect",
                         L"Long range interaction"])
	setp(xlab,"FontSize",20)
	setp(ylab,"FontSize",20)
	savefig("pcrit_sparse.png")
	#surf([i for i=1:n],log(pp),lam,cmap=ColorMap("coolwarm"))

end

function write_f(n,pp)
	@time begin
		(pp,lam)=feidler(n,pp)
	end
	writedlm("fiedler.txt", lam)
	#surf([i for i=1:n],log(pp),lam,cmap=ColorMap("coolwarm"))
end




